

#ifndef _SFM_HH
#define _SFM_HH

#include <qapp.h>

#include "iconview.hh"
#include "deskicon.hh"

#include <X11/Xlib.h>

class Sfm : public QApplication {

  Q_OBJECT ;

  QList<IconView> *winList ;
  QListIterator<IconView> *winIt ; 
  WId *winIds ;
  QList<DeskIcon> *diList ;
  QListIterator<DeskIcon> *diIt ;

  Window *stackList ;
  uint stackLen ;

  bool retrieveSession () ;

  signals:
  void dragDropHighlight (WId, const QPoint &, const QList<DeskIcon> &)  ;
  void drag_drop_happened (WId, const QPoint &p, const QList<DeskIcon> &) ; 
  void broadcast_file_change (const QFileInfo &, const QFileInfo &) ;
  
public:
  Sfm (int argc, char **argv) ;
  
 public slots:
  void open (const QDir &d) {
    winList->append (new IconView (d, this)) ;
    winList->current()->show() ;
  } 
  
  void openAppl (const char *c) {
    winList->append (new IconView (c, this)) ;
    winList->current()->show () ;
  }
  
  void open (const char *c) {
    open (QDir (c)) ;
  }

  void close (IconView *iv) {
    winList->removeRef (iv) ;
    delete iv ;
    if (winList->isEmpty ())
	quit () ;
  }

  void slot_file_change (const QFileInfo &, const QFileInfo &) ;

  void slot_refresh () ;

  void dragPointAt (const QPoint &p, const QList<DeskIcon> & =0) ;
  void dragDropRelease (const QPoint &, const QList<DeskIcon> &) ;

} ;


#endif // _SFM_HH
